diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ctrl-headers.h ns-3.34/src/wifi/model/ctrl-headers.h
--- ns-3.33/src/wifi/model/ctrl-headers.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ctrl-headers.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,11 +21,18 @@
 #ifndef CTRL_HEADERS_H
 #define CTRL_HEADERS_H
 
+#include <list>
+#include <vector>
 #include "ns3/header.h"
 #include "block-ack-type.h"
+#include "ns3/he-ru.h"
+#include "ns3/mac48-address.h"
 
 namespace ns3 {
 
+class WifiTxVector;
+enum AcIndex : uint8_t;
+
 /**
  * \ingroup wifi
  * \brief Headers for BlockAckRequest.
@@ -48,11 +55,12 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
-  void Print (std::ostream &os) const;
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (Buffer::Iterator start) const;
-  uint32_t Deserialize (Buffer::Iterator start);
+
+  TypeId GetInstanceTypeId (void) const override;
+  void Print (std::ostream &os) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (Buffer::Iterator start) const override;
+  uint32_t Deserialize (Buffer::Iterator start) override;
 
   /**
    * Enable or disable HT immediate Ack.
@@ -61,11 +69,11 @@
    */
   void SetHtImmediateAck (bool immediateAck);
   /**
-   * Set the block ack type.
+   * Set the BlockAckRequest type.
    *
-   * \param type the BA type
+   * \param type the BlockAckRequest type
    */
-  void SetType (BlockAckType type);
+  void SetType (BlockAckReqType type);
   /**
    * Set Traffic ID (TID).
    *
@@ -88,11 +96,11 @@
    */
   bool MustSendHtImmediateAck (void) const;
   /**
-   * Return the Block Ack type ID.
+   * Return the BlockAckRequest type.
    *
-   * \return the BA type
+   * \return the type of the BlockAckRequest
    */
-  BlockAckType GetType (void) const;
+  BlockAckReqType GetType (void) const;
   /**
    * Return the Traffic ID (TID).
    *
@@ -171,10 +179,10 @@
    * For now only non HT immediate BlockAck is implemented so this field
    * is here only for a future implementation of HT delayed variant.
    */
-  bool m_barAckPolicy;    ///< BAR Ack Policy
-  BlockAckType m_baType;  ///< BA type
-  uint16_t m_tidInfo;     ///< TID info
-  uint16_t m_startingSeq; ///< starting sequence number
+  bool m_barAckPolicy;       ///< bar ack policy
+  BlockAckReqType m_barType; ///< BAR type
+  uint16_t m_tidInfo;        ///< TID info
+  uint16_t m_startingSeq;    ///< starting seq
 };
 
 
@@ -219,18 +227,25 @@
    */
   void SetType (BlockAckType type);
   /**
-   * Set Traffic ID (TID).
+   * For Block Ack variants other than Multi-STA Block Ack, set the TID_INFO subfield
+   * of the BA Control field. For Multi-STA Block Acks, set the TID subfield of the
+   * AID TID Info subfield of the Per AID TID Info subfield identified by the given
+   * index.
    *
-   * \param tid the TID
+   * \param tid the traffic ID
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    */
-  void SetTidInfo (uint8_t tid);
+  void SetTidInfo (uint8_t tid, std::size_t index = 0);
   /**
-   * Set the starting sequence number from the given
-   * raw sequence control field.
+   * For Block Ack variants other than Multi-STA Block Ack, set the starting sequence
+   * number to the given value. For Multi-STA Block Acks, set the starting sequence
+   * number in the Per AID TID Info subfield identified by the given index to the
+   * given value.
    *
-   * \param seq the raw sequence control
+   * \param seq the starting sequence number
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    */
-  void SetStartingSequence (uint16_t seq);
+  void SetStartingSequence (uint16_t seq, std::size_t index = 0);
 
   /**
    * Check if the current Ack Policy is immediate.
@@ -246,17 +261,24 @@
    */
   BlockAckType GetType (void) const;
   /**
-   * Return the Traffic ID (TID).
+   * For Block Ack variants other than Multi-STA Block Ack, get the TID_INFO subfield
+   * of the BA Control field. For Multi-STA Block Acks, get the TID subfield of the
+   * AID TID Info subfield of the Per AID TID Info subfield identified by the given
+   * index.
    *
-   * \return TID
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
+   * \return the Traffic ID
    */
-  uint8_t GetTidInfo (void) const;
+  uint8_t GetTidInfo (std::size_t index = 0) const;
   /**
-   * Return the starting sequence number.
+   * For Block Ack variants other than Multi-STA Block Ack, get the starting sequence
+   * number. For Multi-STA Block Acks, get the starting sequence number in the
+   * Per AID TID Info subfield identified by the given index.
    *
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    * \return the starting sequence number
    */
-  uint16_t GetStartingSequence (void) const;
+  uint16_t GetStartingSequence (std::size_t index = 0) const;
   /**
    * Check if the current BA policy is Basic Block Ack.
    *
@@ -285,14 +307,90 @@
    *         false otherwise
    */
   bool IsMultiTid (void) const;
+  /**
+   * Check if the BlockAck frame variant is Multi-STA Block Ack.
+   *
+   * \return true if the BlockAck frame variant is Multi-STA Block Ack,
+   *         false otherwise
+   */
+  bool IsMultiSta (void) const;
 
   /**
-   * Set the bitmap that the packet with the given sequence
-   * number was received.
+   * For Multi-STA Block Acks, set the AID11 subfield of the Per AID TID Info
+   * subfield identified by the given index to the given value
    *
-   * \param seq the sequence number
+   * \param aid the AID11 value
+   * \param index the index of the Per AID TID Info subfield
+   */
+  void SetAid11 (uint16_t aid, std::size_t index);
+  /**
+   * For Multi-STA Block Acks, get the AID11 subfield of the Per AID TID Info
+   * subfield identified by the given index.
+   *
+   * \param index the index of the Per AID TID Info subfield
+   * \return the AID11 subfield
+   */
+  uint16_t GetAid11 (std::size_t index) const;
+  /**
+   * For Multi-STA Block Acks, set the Ack Type subfield of the Per AID TID Info
+   * subfield identified by the given index to the given value
+   *
+   * \param type the ack type value
+   * \param index the index of the Per AID TID Info subfield
+   */
+  void SetAckType (bool type, std::size_t index);
+  /**
+   * For Multi-STA Block Acks, get the Ack Type subfield of the Per AID TID Info
+   * subfield identified by the given index.
+   *
+   * \param index the index of the Per AID TID Info subfield
+   * \return the Ack Type
+   */
+  bool GetAckType (std::size_t index) const;
+  /**
+   * For Multi-STA Block Acks, set the RA subfield of the Per AID TID Info
+   * subfield (with AID11 subfield equal to 2045) identified by the given index
+   * to the given MAC address.
+   *
+   * \param ra the MAC address
+   * \param index the index of the Per AID TID Info subfield
+   */
+  void SetUnassociatedStaAddress (const Mac48Address& ra, std::size_t index);
+  /**
+   * For Multi-STA Block Acks, get the RA subfield of the Per AID TID Info
+   * subfield (with AID11 subfield equal to 2045) identified by the given index
+   * to the given MAC address.
+   *
+   * \param index the index of the Per AID TID Info subfield
+   * \return the MAC address stored in the RA subfield
+   */
+  Mac48Address GetUnassociatedStaAddress (std::size_t index) const;
+  /**
+   * For Multi-STA Block Acks, get the number of Per AID TID Info subfields
+   * included in this Block Ack.
+   *
+   * \return the number of Per AID TID Info subfields included in this Multi-STA Block Ack
    */
-  void SetReceivedPacket (uint16_t seq);
+  std::size_t GetNPerAidTidInfoSubfields (void) const;
+  /**
+   * For Multi-STA Block Acks, get the indices of the Per AID TID Info subfields
+   * carrying the given AID in the AID11 subfield.
+   *
+   * \param aid the given AID
+   * \return a vector containing the indices of the Per AID TID Info subfields
+   *         carrying the given AID in the AID11 subfield
+   */
+  std::vector<uint32_t> FindPerAidTidInfoWithAid (uint16_t aid) const;
+
+  /**
+   * Record in the bitmap that the packet with the given sequence number was
+   * received. For Multi-STA Block Acks, <i>index</i> identifies the Per AID
+   * TID Info subfield whose bitmap has to be updated.
+   *
+   * \param seq the sequence number of the received packet
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
+   */
+  void SetReceivedPacket (uint16_t seq, std::size_t index = 0);
   /**
    * Set the bitmap that the packet with the given sequence
    * number and fragment number was received.
@@ -302,14 +400,16 @@
    */
   void SetReceivedFragment (uint16_t seq, uint8_t frag);
   /**
-   * Check if the packet with the given sequence number
-   * was acknowledged in this BlockAck response.
+   * Check if the packet with the given sequence number was acknowledged in this
+   * BlockAck response. For Multi-STA Block Acks, <i>index</i> identifies the
+   * Per AID TID Info subfield whose bitmap has to be checked.
    *
-   * \param seq the sequence number
+   * \param seq the sequence number to be checked
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    * \return true if the packet with the given sequence number
    *         was ACKed in this BlockAck response, false otherwise
    */
-  bool IsPacketReceived (uint16_t seq) const;
+  bool IsPacketReceived (uint16_t seq, std::size_t index = 0) const;
   /**
    * Check if the packet with the given sequence number
    * and fragment number was acknowledged in this BlockAck response.
@@ -323,41 +423,40 @@
   bool IsFragmentReceived (uint16_t seq, uint8_t frag) const;
 
   /**
-   * Return the starting sequence control.
-   *
-   * \return the starting sequence control
-   */
-  uint16_t GetStartingSequenceControl (void) const;
-  /**
-   * Set the starting sequence control with the given
-   * sequence control value
+   * Return the value of the Starting Sequence Control subfield. For Multi-STA
+   * Block Acks, <i>index</i> identifies the Per AID TID Info subfield whose
+   * Starting Sequence Control subfield has to be returned.
+   *
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
+   * \return the value of the Starting Sequence Control subfield
+   */
+  uint16_t GetStartingSequenceControl (std::size_t index = 0) const;
+  /**
+   * Set the Starting Sequence Control subfield with the given sequence control
+   * value. For Multi-STA Block Acks, <i>index</i> identifies the Per AID TID Info
+   * subfield whose Starting Sequence Control subfield has to be set.
    *
    * \param seqControl the raw sequence control value
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    */
-  void SetStartingSequenceControl (uint16_t seqControl);
-  /**
-   * Return the bitmap from the BlockAck response header.
-   *
-   * \return the bitmap from the BlockAck response header
-   */
-  const uint16_t* GetBitmap (void) const;
-  /**
-   * Return the compressed bitmap from the BlockAck response header.
-   *
-   * \return the compressed bitmap from the BlockAck response header
-   */
-  uint64_t GetCompressedBitmap (void) const;
+  void SetStartingSequenceControl (uint16_t seqControl, std::size_t index = 0);
   /**
-   * Return the extended compressed bitmap from the BlockAck response header.
+   * Return a const reference to the bitmap from the BlockAck response header.
+   * For Multi-STA Block Acks, return a const reference to the bitmap included
+   * in the Per AID TID Info subfield identified by <i>index</i>.
    *
-   * \return the extended compressed bitmap from the BlockAck response header
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
+   * \return a const reference to the bitmap from the BlockAck response header
    */
-  const uint64_t* GetExtendedCompressedBitmap (void) const;
+  const std::vector<uint8_t>& GetBitmap (std::size_t index = 0) const;
 
   /**
-   * Reset the bitmap to 0.
+   * Reset the bitmap to 0. For Multi-STA Block Acks, reset the bitmap included
+   * in the Per AID TID Info subfield identified by <i>index</i>.
+   *
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    */
-  void ResetBitmap (void);
+  void ResetBitmap (std::size_t index = 0);
 
 
 private:
@@ -375,19 +474,23 @@
   void SetBaControl (uint16_t ba);
 
   /**
-   * Serialize bitmap to the given buffer.
+   * Serialize bitmap to the given buffer. For Multi-STA Block Acks, <i>index</i>
+   * identifies the Per AID TID Info subfield whose bitmap has to be serialized.
    *
-   * \param start the iterator
+   * \param start iterator pointing to the beginning of the buffer to write into.
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    * \return Buffer::Iterator to the next available buffer
    */
-  Buffer::Iterator SerializeBitmap (Buffer::Iterator start) const;
+  Buffer::Iterator SerializeBitmap (Buffer::Iterator start, std::size_t index = 0) const;
   /**
-   * Deserialize bitmap from the given buffer.
+   * Deserialize bitmap from the given buffer. For Multi-STA Block Acks, <i>index</i>
+   * identifies the Per AID TID Info subfield whose bitmap has to be deserialized.
    *
-   * \param start the iterator
+   * \param start iterator pointing to the beginning of the buffer to read from.
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    * \return Buffer::Iterator to the next available buffer
    */
-  Buffer::Iterator DeserializeBitmap (Buffer::Iterator start);
+  Buffer::Iterator DeserializeBitmap (Buffer::Iterator start, std::size_t index = 0);
 
   /**
    * This function is used to correctly index in both bitmap
@@ -396,6 +499,7 @@
    * for more details see 7.2.1.8 in IEEE 802.11n/D4.00
    *
    * \param seq the sequence number
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    *
    * \return If we are using basic block ack, return value represents index of
    * block of 16 bits for packet having sequence number equals to <i>seq</i>.
@@ -403,16 +507,18 @@
    * to set to 1 in the compressed bitmap to indicate that packet having
    * sequence number equals to <i>seq</i> was correctly received.
    */
-  uint16_t IndexInBitmap (uint16_t seq) const;
+  uint16_t IndexInBitmap (uint16_t seq, std::size_t index = 0) const;
 
   /**
-   * Checks if sequence number <i>seq</i> can be acknowledged in the bitmap.
+   * Check if sequence number <i>seq</i> can be acknowledged in the bitmap. For
+   * Multi-STA Block Acks, check if sequence number <i>seq</i> can be acknowledged
+   * in the bitmap included in the Per AID TID Info subfield identified by <i>index</i>.
    *
    * \param seq the sequence number
-   *
+   * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
    * \return true if the sequence number is concerned by the bitmap
    */
-  bool IsInBitmap (uint16_t seq) const;
+  bool IsInBitmap (uint16_t seq, std::size_t index = 0) const;
 
   /**
    * The LSB bit of the BA control field is used only for the
